

import java.util.Hashtable;

import oasis.names.tc.dss._1_0.core.wsdl.SOAPport;
import oasis.names.tc.dss._1_0.core.wsdl.digitalSignatureServiceClient;

import org.apache.xmlbeans.XmlOptions;


import x0CoreSchema.oasisNamesTcDss1.SignatureObjectType;
import x0CoreSchema.oasisNamesTcDss1.VerifyRequestDocument;
import x0CoreSchema.oasisNamesTcDss1.VerifyResponseDocument;
import x0CoreSchema.oasisNamesTcDss1.VerifyRequestDocument.VerifyRequest;

public class ValidacioSignaturaXAdES {

	@SuppressWarnings("unchecked")
	public static void main(String args[]) throws Exception {

		// Configuració local
		Utils.setProxyConfiguration();

		// Dades de prova
		
		// Signatura a verificar
		String signature = Utils.readXmlFile("proves\\data\\xades-signature.dat");

		// Inicialització del client
		digitalSignatureServiceClient proxy = new digitalSignatureServiceClient();
		SOAPport port = proxy.getdssPortSoap("http://psisbeta.catcert.net/psis/catcert-test/dss");

		// Composició del missatge

		// Definició dels namespaces correctes
		Hashtable prefixes = new Hashtable();
		prefixes.put("urn:oasis:names:tc:dss:1.0:core:schema","dss");
		prefixes.put("http://www.w3.org/2000/09/xmldsig#","ds");

		XmlOptions options= new XmlOptions();	
		options.setSaveSuggestedPrefixes(prefixes);

		// Creació del missatge DSS
		VerifyRequestDocument requestDocument = VerifyRequestDocument.Factory.newInstance(options);
		
		VerifyRequest request = requestDocument.addNewVerifyRequest();
		
		// Creació de l'element amb la signatura XAdES
		SignatureObjectType signaturetype = SignatureObjectType.Factory.parse(signature,options);
		
		request.setSignatureObject(signaturetype);
		
		// Creació de l'element amb els paràmetres opcionals a consultar
		// OptionalInputs optInputs = OptionalInputs.Factory.newInstance(options);
		// optInputs.addNewReturnProcessingDetails();

		// request.setOptionalInputs(optInputs);

		// Visualització de la petició
		System.out.println(requestDocument.xmlText(options));

		// Execució del servei
		VerifyResponseDocument responseDocument = port.verify(requestDocument);

		// visualització de la resposta
		System.out.println(responseDocument.xmlText(options));

	}
}
